/*
 * This utility implements the Revised CR rules found in "Immortals Handbook" by Craig Cochrane, Copyright 2001-2004.
 * This utility was written by Brandon Felger, Copyright 2004.
 * You are free to use, modify and distribute this utility freely as long as this notice and all copyrights are preserved.
 */

function recalc() {
	var StrScore = parseInt(document.stats.StrScore.value);
	var DexScore = parseInt(document.stats.DexScore.value);
	var ConScore = parseInt(document.stats.ConScore.value);
	var IntScore = parseInt(document.stats.IntScore.value);
	var WisScore = parseInt(document.stats.WisScore.value);
	var ChaScore = parseInt(document.stats.ChaScore.value);
	
	var TotalCra=0;
	
	recalcSubTypeColors();
	recalcClass();
	
	TotalCra += parseFloat(document.stats.PcClassTotalCra.value);
	TotalCra += parseFloat(document.stats.WarriorTotalCra.value);
	TotalCra += parseFloat(document.stats.AristocratTotalCra.value);
	TotalCra += parseFloat(document.stats.ExpertTotalCra.value);
	TotalCra += parseFloat(document.stats.AdeptTotalCra.value);
	TotalCra += parseFloat(document.stats.CommonerTotalCra.value);

	switch (document.stats.SizeMod.value) {
		case "-4":	document.stats.SizeCra.value="-0.35";	document.stats.SizeNoConCra.value="-0.15";	break;
		case "-3":	document.stats.SizeCra.value="-0.8";	document.stats.SizeNoConCra.value="-0.6";	break;
		case "-2":	document.stats.SizeCra.value="-0.85";	document.stats.SizeNoConCra.value="-0.65";	break;
		case "-1":	document.stats.SizeCra.value="-0.4";	document.stats.SizeNoConCra.value="-0.2";	break;
		case "0":	document.stats.SizeCra.value="0";		document.stats.SizeNoConCra.value="0";		break;
		case "1":	document.stats.SizeCra.value="1.2";		document.stats.SizeNoConCra.value="0.8";	break;
		case "2":	document.stats.SizeCra.value="2.4";		document.stats.SizeNoConCra.value="1.6";	break;
		case "3":	document.stats.SizeCra.value="3.6";		document.stats.SizeNoConCra.value="2.4";	break;
		case "4":	document.stats.SizeCra.value="4.4";		document.stats.SizeNoConCra.value="2.8";	break;
		case "5":	document.stats.SizeCra.value="4.4";		document.stats.SizeNoConCra.value="4.4";	break;
		case "6":	document.stats.SizeCra.value="2.8";		document.stats.SizeNoConCra.value="0.4";	break;
		case "7":	document.stats.SizeCra.value="-2.2";	document.stats.SizeNoConCra.value="-5";		break;
		case "8":	document.stats.SizeCra.value="-13.2";	document.stats.SizeNoConCra.value="-16.4";	break;
		default:	;
	};

	if (document.stats.Type.value != "Humanoid") {
		document.stats.Race.value="None";
		document.stats.Race.disabled=true;
		document.stats.RaceCra.className="cra";
	} else {
		document.stats.Race.disabled=false;
		document.stats.RaceCra.className="cra-active";
	}
	
	switch (document.stats.Race.value) {
		case "None":		document.stats.RaceCra.value="0";		break;
		case "Dwarf":		document.stats.RaceCra.value="0.51";
							ConScore += 2;
							ChaScore -= 2;
							break;
		case "Elf":			document.stats.RaceCra.value="0.36";
							DexScore += 2;
							ConScore -= 2;
							break;
		case "Gnome":		document.stats.RaceCra.value="0.3625";
							ConScore += 2;
							StrScore -= 2;
							break;
		case "Half-Elf":	document.stats.RaceCra.value="0.38";	break;
		case "Halfling":	document.stats.RaceCra.value="0.48";	break;
		case "Half-Orc":	document.stats.RaceCra.value="0";
							StrScore += 2;
							IntScore -= 2;
							ChaScore -= 2;
							break;
		case "Human":		document.stats.RaceCra.value="0.3";		break;
							break;
		case "Goblinoid":	document.stats.RaceCra.value="0.2";		break;
	}
	
	if (document.stats.Race.value != "None")
		TotalCra+=parseFloat(document.stats.RaceCra.value);
	
	if (StrScore < 3)
		StrScore = 3;
	if (DexScore < 3)
		DexScore = 3;
	if (ConScore < 3)
		ConScore = 3;
	if (IntScore < 3 && document.stats.Type.value != "Animal")
		IntScore = 3;
	if (WisScore < 3)
		WisScore = 3;
	if (ChaScore < 3)
		ChaScore = 3;
		
	document.stats.ConScore.disabled=false;
	document.stats.IntScore.disabled=false;
	
	document.stats.SizeCra.className="cra-active";
	document.stats.SizeNoConCra.className="cra";
	
	switch (document.stats.Type.value) {
		case "Aberration":
										document.stats.TypeCra.value="0.2";
										document.stats.CraPerHd.value="0.55";
										break;
		case "Animal":
										document.stats.TypeCra.value="-0.75";
										if (IntScore > 2)
											IntScore = 2;
										else if (IntScore < 1)
											IntScore = 1;
										document.stats.CraPerHd.value="0.55";
										break;
		case "Construct":
										document.stats.TypeCra.value="0.7";
										document.stats.ConScore.disabled=true;
										document.stats.IntScore.disabled=true;
										ConScore = 0;
										IntScore = 0;
										document.stats.CraPerHd.value="0.35";
										document.stats.SizeCra.className="cra";
										document.stats.SizeNoConCra.className="cra-active";
										break;
		case "Construct (Intelligent)":
										document.stats.TypeCra.value="2.4";
										document.stats.ConScore.disabled=true;
										ConScore = 0;
										document.stats.CraPerHd.value="0.45"
										document.stats.SizeCra.className="cra";
										document.stats.SizeNoConCra.className="cra-active";
										break;
		case "Dragon":
										document.stats.TypeCra.value="0.5";
										document.stats.CraPerHd.value="0.75";
										break;
		case "Elemental":
										document.stats.TypeCra.value="1.2";
										document.stats.CraPerHd.value="0.55";
										break;
		case "Fey":
										document.stats.TypeCra.value="0.1";
										document.stats.CraPerHd.value="0.5";
										break;
		case "Giant":
										document.stats.TypeCra.value="0.2";
										document.stats.CraPerHd.value="0.55";
										break;
		case "Humanoid":
										document.stats.TypeCra.value="0";
										document.stats.CraPerHd.value="0.55";
										break;
		case "Magical Beast":
										document.stats.TypeCra.value="0.2";
										document.stats.CraPerHd.value="0.65";
										break;
		case "Monstrous Humanoid":
										document.stats.TypeCra.value="0.2";
										document.stats.CraPerHd.value = "0.6";
										break;
		case "Ooze":
										document.stats.TypeCra.value="1.9";
										document.stats.IntScore.disabled=true;
										IntScore = 0;
										document.stats.CraPerHd.value = "0.45";
										break;
		case "Ooze (Intelligent)":
										document.stats.TypeCra.value="2.6";
										document.stats.CraPerHd.value="0.55";
										break;
		case "Outsider":
										document.stats.TypeCra.value="0";
										document.stats.CraPerHd.value="0.7";
										break;
		case "Plant":
										document.stats.TypeCra.value="1.8";
										document.stats.CraPerHd.value="0.45";
										break;
		case "Undead (Intelligent)":
										document.stats.TypeCra.value="1.6";
										document.stats.ConScore.disabled=true;
										ConScore = 0;
										document.stats.CraPerHd.value="0.45";
										document.stats.SizeCra.className="cra";
										document.stats.SizeNoConCra.className="cra-active";
										break;
		case "Undead (Mindless)":
										document.stats.TypeCra.value="-0.6";
										document.stats.ConScore.disabled=true;
										document.stats.IntScore.disabled=true;
										ConScore = 0;
										IntScore = 0;
										document.stats.CraPerHd.value="0.35";
										document.stats.SizeCra.className="cra";
										document.stats.SizeNoConCra.className="cra-active";
										break;
		case "Vermin":
										document.stats.TypeCra.value="-0.5";
										document.stats.CraPerHd.value="0.45";
										break;
		default:						;
	};
	
	TotalCra+=parseFloat(document.stats.TypeCra.value);
	
	if (document.stats.ConScore.disabled == true)
		TotalCra += parseFloat(document.stats.SizeNoConCra.value);
	else
		TotalCra += parseFloat(document.stats.SizeCra.value);
	
	document.stats.StrScoreTotal.value=StrScore;
	document.stats.DexScoreTotal.value=DexScore;
	document.stats.ConScoreTotal.value=ConScore;
	document.stats.IntScoreTotal.value=IntScore;
	document.stats.WisScoreTotal.value=WisScore;
	document.stats.ChaScoreTotal.value=ChaScore;
	
	StrCra = (StrScore-10)*0.1;
	DexCra = (DexScore-10)*0.1;
	ConCra = (ConScore-10)*0.1;
	IntCra = (IntScore-10)*0.1;
	WisCra = (WisScore-10)*0.1;
	ChaCra = (ChaScore-10)*0.1;
	
	if (StrScore <= 0)
		StrCra = -2.2;
	if (DexScore <= 0)
		DexCra = -2.2;
	if (ConScore <= 0)
		ConCra = 1.9;
	if (IntScore <= 0)
		IntCra = -0.7;
	
	document.stats.StrCra.value=StrCra;
	document.stats.DexCra.value=DexCra;
	document.stats.ConCra.value=ConCra;
	document.stats.IntCra.value=IntCra;
	document.stats.WisCra.value=WisCra;
	document.stats.ChaCra.value=ChaCra;
	
	TotalCra += StrCra+DexCra+ConCra+IntCra+WisCra+ChaCra;
	
	document.stats.HitDiceCra.value=document.stats.HitDice.value*document.stats.CraPerHd.value;
	
	if (document.stats.Burrow.value == "None") {
		document.stats.BurrowAvgSpeed.value="0";
		document.stats.BurrowCra.value="0";
		document.stats.BurrowCra.className = "cra";
		document.stats.BurrowSpeed.value="0";
		document.stats.BurrowSpeed.disabled=true;
	} else {
		var SpeedCra=0;
		if (document.stats.Burrow.value == "Soil")
			SpeedCra = 0.2;
		else
			SpeedCra = 0.5;
		Speed = (parseInt(document.stats.SizeMod.value)+3)*10;
		if (document.stats.SizeMod.value == "-4")
			Speed="5";
		else if (document.stats.SizeMod.value == "-3")
			Speed="10";
		else if (document.stats.SizeMod.value == "-2")
			Speed="15";
		else if (Speed > "70")
			Speed="70";
		if (parseInt(document.stats.BurrowSpeed.value) < "5")
			document.stats.BurrowSpeed.value = Speed;
		if (parseInt(document.stats.BurrowSpeed.value) > Speed)
			SpeedCra += (parseInt(document.stats.BurrowSpeed.value/Speed)-1)*0.2;
		else if (document.stats.BurrowSpeed.value < Speed)
			SpeedCra -= (parseInt(Speed/document.stats.BurrowSpeed.value)-1)*0.2;
		document.stats.BurrowAvgSpeed.value=Speed;
		document.stats.BurrowCra.value=SpeedCra;
		document.stats.BurrowCra.className="cra-active";
		document.stats.BurrowSpeed.disabled=false;
		TotalCra += SpeedCra;
	}

	if (document.stats.Climb.value == "No") {
		document.stats.ClimbCra.value="0";
		document.stats.ClimbCra.className = "cra";
		document.stats.ClimbSpeed.value="0";
	} else {
		Speed = (parseInt(document.stats.SizeMod.value)+3)*10;
		if (document.stats.SizeMod.value == "-4")
			Speed="5";
		else if (document.stats.SizeMod.value == "-3")
			Speed="10";
		else if (document.stats.SizeMod.value == "-2")
			Speed="15";
		else if (Speed > "70")
			Speed="70";
		document.stats.ClimbSpeed.value=Speed;
		document.stats.ClimbCra.value="0.2";
		document.stats.ClimbCra.className="cra-active";
		TotalCra += parseFloat(document.stats.ClimbCra.value);
	}

	if (document.stats.Fly.value == "None") {
		document.stats.FlyAvgSpeed.value="0";
		document.stats.FlyCra.value="0";
		document.stats.FlyCra.className = "cra";
		document.stats.FlySpeed.value="0";
		document.stats.FlySpeed.disabled=true;
	} else {
		var SpeedCra=0;
		if (document.stats.Fly.value == "Clumsy")
			SpeedCra = 0.2;
		else if (document.stats.Fly.value == "Poor")
			SpeedCra = 0.4;
		else if (document.stats.Fly.value == "Average")
			SpeedCra = 0.6;
		else if (document.stats.Fly.value == "Good")
			SpeedCra = 0.8;
		else if (document.stats.Fly.value == "Perfect")
			SpeedCra = 1;
		Speed = (parseInt(document.stats.SizeMod.value)+3)*20;
		if (document.stats.SizeMod.value == "-4")
			Speed="10";
		else if (document.stats.SizeMod.value == "-3")
			Speed="20";
		else if (document.stats.SizeMod.value == "-2")
			Speed="30";
		else if (Speed > "70")
			Speed="70";
		if (parseInt(document.stats.FlySpeed.value) < "5")
			document.stats.FlySpeed.value = Speed;
		if (parseInt(document.stats.FlySpeed.value) > Speed)
			SpeedCra += (parseInt(document.stats.FlySpeed.value/Speed)-1)*0.2;
		else if (document.stats.FlySpeed.value < Speed)
			SpeedCra -= (parseInt(Speed/document.stats.FlySpeed.value)-1)*0.2;
		document.stats.FlyAvgSpeed.value=Speed;
		document.stats.FlyCra.value=SpeedCra;
		document.stats.FlyCra.className="cra-active";
		document.stats.FlySpeed.disabled=false;
		TotalCra += SpeedCra;
	}

	if (document.stats.NoRun.value == "No") {
		document.stats.NoRunCra.value="0";
		document.stats.NoRunCra.className = "cra";
	} else {
		document.stats.NoRunCra.value="-0.2";
		document.stats.NoRunCra.className="cra-active";
	}
	
	if (document.stats.Swim.value == "No") {
		document.stats.SwimAvgSpeed.value="0";
		document.stats.SwimCra.value="0";
		document.stats.SwimCra.className="cra";
		document.stats.SwimSpeed.value="0";
		document.stats.SwimSpeed.disabled=true;
	} else {
		var SpeedCra=0.2;
		Speed=(parseInt(document.stats.SizeMod.value)+3)*10;
		if (document.stats.SizeMod.value == "-4")
			Speed="5";
		else if (document.stats.SizeMod.value == "-3")
			Speed="10";
		else if (document.stats.SizeMod.value == "-2")
			Speed="15";
		else if (Speed > "70")
			Speed="70";
		if (parseInt(document.stats.SwimSpeed.value) < "5")
			document.stats.SwimSpeed.value = Speed;
		if (parseInt(document.stats.SwimSpeed.value) > Speed)
			SpeedCra += (parseInt(document.stats.SwimSpeed.value/Speed)-1)*0.2;
		else if (parseInt(document.stats.SwimSpeed.value) < Speed)
			SpeedCra -= (parseInt(Speed/document.stats.SwimSpeed.value)-1)*0.2;
		document.stats.SwimAvgSpeed.value=Speed;
		document.stats.SwimCra.value=SpeedCra;
		document.stats.SwimCra.className="cra-active";
		document.stats.SwimSpeed.disabled=false;
		TotalCra += SpeedCra;
	}
	
	if (document.stats.NaturalAcBonus.value == "0")
		document.stats.NaturalAcBonusCra.className="cra";
	else
		document.stats.NaturalAcBonusCra.className="cra-active";
	
	if (document.stats.DeflectAcBonus.value == "0")
		document.stats.DeflectAcBonusCra.className="cra";
	else
		document.stats.DeflectAcBonusCra.className="cra-active";

	if (document.stats.InsightAcBonus.value == "0")
		document.stats.InsightAcBonusCra.className="cra";
	else
		document.stats.InsightAcBonusCra.className="cra-active";

	document.stats.NaturalAcBonusCra.value=parseInt(document.stats.NaturalAcBonus.value)*0.1;
	document.stats.DeflectAcBonusCra.value=parseInt(document.stats.DeflectAcBonus.value)*0.1;
	document.stats.InsightAcBonusCra.value=parseInt(document.stats.InsightAcBonus.value)*0.125;
	
	TotalCra += parseFloat(document.stats.NaturalAcBonusCra.value);
	TotalCra += parseFloat(document.stats.DeflectAcBonusCra.value);
	TotalCra += parseFloat(document.stats.InsightAcBonusCra.value);
	
	if  (document.stats.AttackNumAttacks1.value != "0") {
		if  (document.stats.AttackPrimary1.value == "Yes")
			CraMult=0.1;
		else
			CraMult=0.05;
		NumDice=parseInt(document.stats.AttackNumDice1.value);
		DiceSides=parseInt(document.stats.AttackDiceSides1.value);
		document.stats.AttackCra1.value=(document.stats.AttackNumAttacks1.value*NumDice*(DiceSides+1)*CraMult)/2;
		document.stats.AttackCra1.className="cra-active";
		TotalCra += parseFloat(document.stats.AttackCra1.value);
	} else {
		document.stats.AttackCra1.value="0";
		document.stats.AttackCra1.className="cra";
	}

	if  (document.stats.AttackNumAttacks2.value != "0") {
		if  (document.stats.AttackPrimary2.value == "Yes")
			CraMult=0.1;
		else
			CraMult=0.05;
		NumDice=parseInt(document.stats.AttackNumDice2.value);
		DiceSides=parseInt(document.stats.AttackDiceSides2.value);
		document.stats.AttackCra2.value=(document.stats.AttackNumAttacks2.value*NumDice*(DiceSides+1)*CraMult)/2;
		document.stats.AttackCra2.className="cra-active";
		TotalCra += parseFloat(document.stats.AttackCra2.value);
	} else {
		document.stats.AttackCra2.value="0";
		document.stats.AttackCra2.className="cra";
	}
	
	if  (document.stats.AttackNumAttacks3.value != "0") {
		if  (document.stats.AttackPrimary3.value == "Yes")
			CraMult=0.1;
		else
			CraMult=0.05;
		NumDice=parseInt(document.stats.AttackNumDice3.value);
		DiceSides=parseInt(document.stats.AttackDiceSides3.value);
		document.stats.AttackCra3.value=(document.stats.AttackNumAttacks3.value*NumDice*(DiceSides+1)*CraMult)/2;
		document.stats.AttackCra3.className="cra-active";
		TotalCra += parseFloat(document.stats.AttackCra3.value);
	} else {
		document.stats.AttackCra3.value="0";
		document.stats.AttackCra3.className="cra";
	}

	if  (document.stats.AttackNumAttacks4.value != "0") {
		if  (document.stats.AttackPrimary4.value == "Yes")
			CraMult=0.1;
		else
			CraMult=0.05;
		NumDice=parseInt(document.stats.AttackNumDice4.value);
		DiceSides=parseInt(document.stats.AttackDiceSides4.value);
		document.stats.AttackCra4.value=(document.stats.AttackNumAttacks4.value*NumDice*(DiceSides+1)*CraMult)/2;
		document.stats.AttackCra4.className="cra-active";
		TotalCra += parseFloat(document.stats.AttackCra4.value);
	} else {
		document.stats.AttackCra4.value="0";
		document.stats.AttackCra4.className="cra";
	}
	
	if  (document.stats.AttackNumAttacks5.value != "0") {
		if  (document.stats.AttackPrimary5.value == "Yes")
			CraMult=0.1;
		else
			CraMult=0.05;
		NumDice=parseInt(document.stats.AttackNumDice5.value);
		DiceSides=parseInt(document.stats.AttackDiceSides5.value);
		document.stats.AttackCra5.value=(document.stats.AttackNumAttacks5.value*NumDice*(DiceSides+1)*CraMult)/2;
		document.stats.AttackCra5.className="cra-active";
		TotalCra += parseFloat(document.stats.AttackCra5.value);
	} else {
		document.stats.AttackCra5.value="0";
		document.stats.AttackCra5.className="cra";
	}

	if (document.stats.Equip.value == "PC")
		document.stats.EquipCra.value = parseInt(document.stats.EquipLevel.value)*0.2;
	else
		document.stats.EquipCra.value = parseInt(document.stats.EquipLevel.value)*0.125;
	
	TotalCra += parseFloat(document.stats.EquipCra.value);
	
	HitDiceCra = parseFloat(document.stats.HitDiceCra.value);
	document.stats.RawCr.value=TotalCra+HitDiceCra;
	
	if (HitDiceCra < TotalCra) {
		document.stats.GoldenCr.value=(HitDiceCra*2)+(TotalCra-HitDiceCra)/2;
	} else {
		document.stats.GoldenCr.value="-";
	}
}

function recalcClass() {
	if (document.stats.PcClassLevels.value > 0)
		document.stats.PcClassTotalCra.className="cra-active";
	else
		document.stats.PcClassTotalCra.className="cra";
	
	if (document.stats.WarriorLevels.value > 0)
		document.stats.WarriorTotalCra.className="cra-active";
	else
		document.stats.WarriorTotalCra.className="cra";
	
	if (document.stats.AristocratLevels.value > 0)
		document.stats.AristocratTotalCra.className="cra-active";
	else
		document.stats.AristocratTotalCra.className="cra";
	
	if (document.stats.ExpertLevels.value > 0)
		document.stats.ExpertTotalCra.className="cra-active";
	else
		document.stats.ExpertTotalCra.className="cra";
	
	if (document.stats.AdeptLevels.value > 0)
		document.stats.AdeptTotalCra.className="cra-active";
	else
		document.stats.AdeptTotalCra.className="cra";
	
	if (document.stats.CommonerLevels.value > 0)
		document.stats.CommonerTotalCra.className="cra-active";
	else
		document.stats.CommonerTotalCra.className="cra";
	
	document.stats.PcClassTotalCra.value=document.stats.PcClassLevels.value*document.stats.PcClassCra.value;
	document.stats.WarriorTotalCra.value=document.stats.WarriorLevels.value*document.stats.WarriorCra.value;
	document.stats.AristocratTotalCra.value=document.stats.AristocratLevels.value*document.stats.AristocratCra.value;
	document.stats.ExpertTotalCra.value=document.stats.ExpertLevels.value*document.stats.ExpertCra.value;
	document.stats.AdeptTotalCra.value=document.stats.AdeptLevels.value*document.stats.AdeptCra.value;
	document.stats.CommonerTotalCra.value=document.stats.CommonerLevels.value*document.stats.CommonerCra.value;
}

function recalcSubTypeColors() {
	if (document.stats.AngelSubType.checked==true)
		document.stats.AngelSubTypeCra.className="cra-active";
	else
		document.stats.AngelSubTypeCra.className="cra";
	
	if (document.stats.ArchonSubType.checked==true)
		document.stats.ArchonSubTypeCra.className="cra-active";
	else
		document.stats.ArchonSubTypeCra.className="cra";
	
	if (document.stats.ColdSubType.checked==true)
		document.stats.ColdSubTypeCra.className="cra-active";
	else
		document.stats.ColdSubTypeCra.className="cra";
	
	if (document.stats.DemonSubType.checked==true)
		document.stats.DemonSubTypeCra.className="cra-active";
	else
		document.stats.DemonSubTypeCra.className="cra";
	
	if (document.stats.DevilSubType.checked==true)
		document.stats.DevilSubTypeCra.className="cra-active";
	else
		document.stats.DevilSubTypeCra.className="cra";
	
	if (document.stats.EladrinSubType.checked==true)
		document.stats.EladrinSubTypeCra.className="cra-active";
	else
		document.stats.EladrinSubTypeCra.className="cra";
	
	if (document.stats.FireSubType.checked==true)
		document.stats.FireSubTypeCra.className="cra-active";
	else
		document.stats.FireSubTypeCra.className="cra";
	
	if (document.stats.GuardinalSubType.checked==true)
		document.stats.GuardinalSubTypeCra.className="cra-active";
	else
		document.stats.GuardinalSubTypeCra.className="cra";
	
	if (document.stats.IncorporealSubType.checked==true)
		document.stats.IncorporealSubTypeCra.className="cra-active";
	else
		document.stats.IncorporealSubTypeCra.className="cra";
	
	if (document.stats.SwarmTinySubType.checked==true)
		document.stats.SwarmTinySubTypeCra.className="cra-active";
	else
		document.stats.SwarmTinySubTypeCra.className="cra";
	
	if (document.stats.SwarmFineSubType.checked==true)
		document.stats.SwarmFineSubTypeCra.className="cra-active";
	else
		document.stats.SwarmFineSubTypeCra.className="cra";
}
